summaryrefslogtreecommitdiff
path: root/tools/check_for_upgrade.sh
diff options
context:
space:
mode:
Diffstat (limited to 'tools/check_for_upgrade.sh')
-rw-r--r--tools/check_for_upgrade.sh52
1 files changed, 28 insertions, 24 deletions
diff --git a/tools/check_for_upgrade.sh b/tools/check_for_upgrade.sh
index b2b356e0c..c8dedcf77 100644
--- a/tools/check_for_upgrade.sh
+++ b/tools/check_for_upgrade.sh
@@ -7,11 +7,11 @@ function _current_epoch() {
}
function _update_zsh_update() {
- echo "LAST_EPOCH=$(_current_epoch)" >! ~/.zsh-update
+ echo "LAST_EPOCH=$(_current_epoch)" >! ${ZSH_CACHE_DIR}/.zsh-update
}
function _upgrade_zsh() {
- env ZSH=$ZSH /bin/sh $ZSH/tools/upgrade.sh
+ env ZSH=$ZSH sh $ZSH/tools/upgrade.sh
# update the zsh file
_update_zsh_update
}
@@ -26,33 +26,37 @@ fi
# oh-my-zsh directory.
[[ -w "$ZSH" ]] || return 0
-if [ -f ~/.zsh-update ]
-then
- . ~/.zsh-update
+# Cancel upgrade if git is unavailable on the system
+whence git >/dev/null || return 0
- if [[ -z "$LAST_EPOCH" ]]; then
- _update_zsh_update && return 0;
- fi
+if mkdir "$ZSH/log/update.lock" 2>/dev/null; then
+ if [ -f ${ZSH_CACHE_DIR}/.zsh-update ]; then
+ . ${ZSH_CACHE_DIR}/.zsh-update
+
+ if [[ -z "$LAST_EPOCH" ]]; then
+ _update_zsh_update
+ rmdir $ZSH/log/update.lock # TODO: fix later
+ return 0
+ fi
- epoch_diff=$(($(_current_epoch) - $LAST_EPOCH))
- if [ $epoch_diff -gt $epoch_target ]
- then
- if [ "$DISABLE_UPDATE_PROMPT" = "true" ]
- then
- _upgrade_zsh
- else
- echo "[Oh My Zsh] Would you like to check for updates?"
- echo "Type Y to update oh-my-zsh: \c"
- read line
- if [ "$line" = Y ] || [ "$line" = y ]; then
+ epoch_diff=$(($(_current_epoch) - $LAST_EPOCH))
+ if [ $epoch_diff -gt $epoch_target ]; then
+ if [ "$DISABLE_UPDATE_PROMPT" = "true" ]; then
_upgrade_zsh
else
- _update_zsh_update
+ echo "[Oh My Zsh] Would you like to update? [Y/n]: \c"
+ read line
+ if [[ "$line" == Y* ]] || [[ "$line" == y* ]] || [ -z "$line" ]; then
+ _upgrade_zsh
+ else
+ _update_zsh_update
+ fi
fi
fi
+ else
+ # create the zsh file
+ _update_zsh_update
fi
-else
- # create the zsh file
- _update_zsh_update
-fi
+ rmdir $ZSH/log/update.lock
+fi